﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SQL_lab_analysis.Classi
{
    public class GestioneCategorie
    {
        public static string access = "Access";
        public static string approach = "Approach";
        public static string solution = "Solution";
        public static string assistance = "Assistance";
        public static string time = "Time";

        public static string cat1 = "cat1";
        public static string cat2 = "cat2";
        public static string cat3 = "cat3";
        public static string cat4 = "cat4";
        public static string cat5 = "cat5";
        public static string cat6 = "cat6";
        public static string cat7 = "cat7";
        
        public static List<Sequenza> GetSequences(Categories window, Categoria currentCat, List<Sequenza> temp)
        {
            List<Sequenza> sequences = new List<Sequenza>();
            int cnt; 
            // ACCESS ============================================================================================================
            if (currentCat.padre.Name == access)
            {
                if (currentCat.Name == cat1)
                {
                    sequences.Clear();

                    DialogInput dialog = new DialogInput("Insert the maximum number of exercises the student accesses to.");

                    if (dialog.ShowDialog() == true)
                    {
                        int num = int.Parse(dialog.UserInput);
                        cnt = 0; 
                        List<Sequenza> list = Access.fewAccesses(num, temp);
                        foreach (Sequenza s in list)
                        {
                            s.seqId = cnt++;
                            sequences.Add(s);
                        }

                        modifyCategoryDescription(window, num);
                    }

                }
                if (currentCat.Name == cat2)
                {
                    sequences.Clear();
                    DialogInput dialog = new DialogInput("Insert the minimum number of exercises the student accesses to.");

                    if (dialog.ShowDialog() == true)
                    {
                        int num = int.Parse(dialog.UserInput);
                        cnt = 0;
                        List<Sequenza> list = Access.manyAccesses(num, temp);
                        foreach (Sequenza s in list)
                        {
                            s.seqId = cnt++;
                            sequences.Add(s);
                        }
                        modifyCategoryDescription(window, num);

                    }
                }
            }

            // APPROACH ==========================================================================================================
            if (currentCat.padre.Name == approach)
            {
                if (currentCat.Name == cat1)
                {
                    sequences.Clear();
                    cnt = 0;
                    List<Sequenza> list = GestioneCategorie.Approach.noGoToNextExUntilSolve(temp);
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }
                if (currentCat.Name == cat2)
                {
                    sequences.Clear();
                    cnt = 0;
                    List<Sequenza> list = GestioneCategorie.Approach.GoToNextExEvenNoSolved(temp);
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }
                if (currentCat.Name == cat3)
                {
                    sequences.Clear();
                    cnt = 0; 
                    List<Sequenza> list = GestioneCategorie.Approach.NoAccessToPreviousEx(temp);
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }
                if (currentCat.Name == cat4)
                {
                    sequences.Clear();

                    DialogInput dialog = new DialogInput("Insert the number of time the student goes back to a previous exercise.");

                    if (dialog.ShowDialog() == true)
                    {
                        int num = int.Parse(dialog.UserInput);
                        cnt = 0; 
                        List<Sequenza> list = GestioneCategorie.Approach.AccessToPreviousEx(num, temp);
                        foreach (Sequenza s in list)
                        {
                            s.seqId = cnt++;
                            sequences.Add(s);
                        }
                    }

                }
            }


            // SOLUTION =========================================================================================================
            if (currentCat.padre.Name == solution)
            {
                if (currentCat.Name == cat1)
                {
                    // ha fatto i primi N esercizi giusti
                    DialogInput dialog = new DialogInput("Insert the number of exercises to be correct from the first exercise.");

                    if (dialog.ShowDialog() == true)
                    {
                        int num = int.Parse(dialog.UserInput);
                        cnt = 0;
                        List<Sequenza> list = GestioneCategorie.Solution.solveFirstNExercises(num, temp);
                        foreach (Sequenza s in list)
                        {
                            s.seqId = cnt++;
                            sequences.Add(s);
                        }
                        modifyCategoryDescription(window, num);

                    }

                }
                if (currentCat.Name == cat2)
                {
                    // ha risolto tutti gli esercizi al primo tentativo
                    List<Sequenza> list = GestioneCategorie.Solution.solveAllExFirstTry(temp);
                    cnt = 0;
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }
                if (currentCat.Name == cat3)
                {
                    // ha risolto almeno 2 esercizi al primo tentativo
                    int num = 2;
                    List<Sequenza> list = GestioneCategorie.Solution.solveNExercisesFirstTry(num, temp);

                    Dictionary<int, Sequenza> list2 = new Dictionary<int, Sequenza>();
                    foreach (Sequenza sequence in list)
                    {
                        bool okseq = false;
                        Sequenza s = new Sequenza();
                        foreach (Sequenza sub in temp)
                        {
                            if (sub.Contains(sequence) && !sub.Equals(sequence) && sub.getLunghezza() == sequence.getLunghezza() + 1)
                            {
                                // controllo se c'è un errore in mezzo agli es o meno.
                                if (Solution.FirstTryCheckNotError(num, sub) && list2.TryGetValue(sub.seqId, out s) == false) // aggiungo solo se non ho ancora aggiunto la sequenza!
                                {
                                    list2.Add(sub.seqId, sub);
                                    okseq = true;
                                }
                            }
                        }

                        if (okseq && list2.TryGetValue(sequence.seqId, out s) == false) // aggiungo solo se non ho ancora aggiunto la sequenza!
                            list2.Add(sequence.seqId, sequence);
                    }
                    cnt = 0;
                    foreach (Sequenza s in list2.Values)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }
                if (currentCat.Name == cat4)
                {
                    // almeno un errore su tutti gli esercizi
                    cnt = 0;
                    List<Sequenza> list = GestioneCategorie.Solution.errorOnAllExercises(temp);
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }
                if (currentCat.Name == cat5)
                {
                    DialogInput dialog = new DialogInput("Insert the number of errors that each exercise must have.");

                    if (dialog.ShowDialog() == true)
                    {
                        int num = int.Parse(dialog.UserInput);
                        cnt = 0;
                        List<Sequenza> list = GestioneCategorie.Solution.NerrorsOnAllExercises(num, temp);
                        foreach (Sequenza s in list)
                        {
                            s.seqId = cnt++;
                            sequences.Add(s);
                        }
                    }
                    // almeno 2 errori su tutti gli esercizi

                }
                if (currentCat.Name == cat6)
                {
                    // almeno 3 errori su un esercizio
                    cnt = 0; 
                    List<Sequenza> list = GestioneCategorie.Solution.atLeastXerrorsOnYExercises(3, 1, temp);
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }

                if(currentCat.Name == cat7)
                {
                    DialogInput dialog = new DialogInput("Insert the number of errors.");

                    if (dialog.ShowDialog() == true)
                    {
                        int num = int.Parse(dialog.UserInput);
                        cnt = 0; 
                        List<Sequenza> list = GestioneCategorie.Solution.atLeastXerrors(num,temp);
                        foreach (Sequenza s in list)
                        {
                            s.seqId = cnt++;
                            sequences.Add(s);
                        }

                        modifyCategoryDescription(window, num);

                    }
                }
            }


            // ASSISTANCE ===================================================================================================
            if (currentCat.padre.Name == assistance)
            {
                if (currentCat.Name == cat1)
                {
                    // ha fatto più di N richieste d'aiuto
                    DialogInput dialog = new DialogInput("Insert the total number of assistance requests made by a student.");

                    if (dialog.ShowDialog() == true)
                    {
                        int num = int.Parse(dialog.UserInput);
                        cnt = 0;
                        List<Sequenza> list = GestioneCategorie.Assistance.manyAssistanceRequest(num, temp);
                        foreach (Sequenza s in list)
                        {
                            s.seqId = cnt++;
                            sequences.Add(s);
                        }
                        modifyCategoryDescription(window, num);

                    }
                }
                if (currentCat.Name == cat2)
                {
                    // non ha fatto richieste d'aiuto
                    cnt = 0;
                    List<Sequenza> list = GestioneCategorie.Assistance.noAssistanceRequest(temp);
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }
                if (currentCat.Name == cat3)
                {
                    // richieste d'aiuto per tutti gli esercizi
                    cnt = 0;
                    List<Sequenza> list = GestioneCategorie.Assistance.AssistanceRequestOnAllEx(temp);
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }
                if (currentCat.Name == cat4)
                {
                    cnt = 0; 
                    List<Sequenza> list = GestioneCategorie.Assistance.manyAssistanceRequestOnNexesercises(2, 1, temp);
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }
                if (currentCat.Name == cat5)
                {
                    cnt = 0; 
                    List<Sequenza> list = GestioneCategorie.Assistance.AssistanceThenImmediatelyCorrect(temp);
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }
                if (currentCat.Name == cat6)
                {
                    List<Sequenza> list = GestioneCategorie.Assistance.AssistanceThenImmediatelyError(temp);
                    cnt = 0; 
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }

                if(currentCat.Name == cat7)
                {
                    List<Sequenza> list = GestioneCategorie.Assistance.AssistanceThenCorrect(temp);
                    cnt = 0;
                    foreach (Sequenza s in list)
                    {
                        s.seqId = cnt++;
                        sequences.Add(s);
                    }
                }
            }

            // TIME =============================================================================================================
            if (currentCat.padre.Name == time)
            {
                if (currentCat.Name == cat1)
                {
                    // ha fatto più di N richieste d'aiuto
                    DialogInput dialog = new DialogInput("Insert the time (minutes).");

                    if (dialog.ShowDialog() == true)
                    {
                        int min = int.Parse(dialog.UserInput);
                        int second = 60 * min;
                        cnt = 0; 
                        List<Sequenza> list = GestioneCategorie.Time.SecondsBetweenAccessAndNext(second, temp);
                        foreach (Sequenza s in list)
                        {
                            s.seqId = cnt++;
                            sequences.Add(s);
                        }
                    }
                }
                if (currentCat.Name == cat2)
                {
                    DialogInput dialog = new DialogInput("Insert the time (minutes).");

                    if (dialog.ShowDialog() == true)
                    {
                        int min = int.Parse(dialog.UserInput);
                        int second = 60 * min;
                        cnt = 0; 
                        List<Sequenza> list = GestioneCategorie.Time.SecondsBetweenAccessAndCorrect(second, temp);
                        foreach (Sequenza s in list)
                        {
                            s.seqId = cnt++;
                            sequences.Add(s);
                        }
                    }
                }
                if (currentCat.Name == cat3)
                {
                    DialogInput dialog = new DialogInput("Insert the time (minutes).");

                    if (dialog.ShowDialog() == true)
                    {
                        int min = int.Parse(dialog.UserInput);
                        int second = 60 * min;
                        cnt = 0; 
                        List<Sequenza> list = GestioneCategorie.Time.SecondsBetweenTryAndNextTry(second, temp);
                        foreach (Sequenza s in list)
                        {
                            s.seqId = cnt++;
                            sequences.Add(s);
                        }
                    }
                }
                if (currentCat.Name == cat4)
                {
                    DialogInput dialog = new DialogInput("Insert the time (minutes).");

                    if (dialog.ShowDialog() == true)
                    {
                        int min = int.Parse(dialog.UserInput);
                        int second = 60 * min;
                        cnt = 0;
                        List<Sequenza> list = GestioneCategorie.Time.SecondsBetweenAssistanceAndCorrect(second, temp);
                        foreach (Sequenza s in list)
                        {
                            s.seqId = cnt++;
                            sequences.Add(s);
                        }
                    }
                }

            }

            return sequences;
        }

        private static void modifyCategoryDescription(Categories window, int num)
        {
            if (window != null)
            {
                string descr = window.CategoryDescription;
                string[] split = descr.Split('*');
                if (split.Length > 1)
                {
                    string news = split[0] + num + split[2];
                    window.CategoryDescription = news;
                }
            }
        }

        public class Access
        {
            public static List<Sequenza> fewAccesses(int numAcc, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (lessThanNumAccess(numAcc, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }

            public static List<Sequenza> manyAccesses(int numAcc, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (moreThanNumAccess(numAcc, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }

            public static bool lessThanNumAccess(int num, Sequenza seq)
            {
                bool ret = false;
                bool[] acc = new bool[LabInfo.totalExercise];

                foreach (Evento evento in seq.getEvents())
                {
                    if (evento.Event == Evento.Accesso)
                        acc[evento.NumEsercizio - 1] = true;
                }
                int cnt = 0;
                foreach (bool b in acc)
                    if (b == true) cnt++;
                if (cnt <= num)
                    ret = true;

                return ret;
            }
            public static bool moreThanNumAccess(int num, Sequenza seq)
            {
                bool ret = false;
                bool[] acc = new bool[LabInfo.totalExercise];

                foreach (Evento evento in seq.getEvents())
                {
                    if (evento.Event == Evento.Accesso)
                        acc[evento.NumEsercizio - 1] = true;
                }
                int cnt = 0;
                foreach (bool b in acc)
                    if (b == true) cnt++;
                if (cnt >= num)
                    ret = true;

                return ret;
            }

        }

        public class Approach
        {
            public static List<Sequenza> noGoToNextExUntilSolve(List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (noUntilSolve(sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool noUntilSolve(Sequenza seq)
            {
                // nel caso di un accesso successivo al secondo esercizio controllo se ha già risolto il precedente. Se non lo ha risolto, lo escludo.
                // nel caso di un accesso successivo al secondo esercizio controllo se ha già risolto i precedenti esercizi a cui ha fatto accesso. Se non li ha risolti, lo escludo.
                bool ret = true;
                bool[] acc = new bool[LabInfo.totalExercise];
                bool[] solve = new bool[LabInfo.totalExercise];
                for (int i = 0; i < seq.Sequence.Count; i++)
                {
                    Evento evento = seq.Sequence[i];
                    if (evento.Event == Evento.Accesso)
                    {
                        acc[evento.NumEsercizio - 1] = true;
                        
                        for(int j = 0; j < evento.NumEsercizio-1; j++)
                        {
                            if(evento.NumEsercizio >= 2 && acc[j] == true && solve[j] == false)
                            {
                                ret = false;
                                break;
                            }
                        }
                        
                    }
                    else if (evento.Event == Evento.Corretto)
                        solve[evento.NumEsercizio - 1] = true;

                }

                return ret;
            }

            public static List<Sequenza> GoToNextExEvenNoSolved(List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (NextExNoSolved(sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool NextExNoSolved(Sequenza seq)
            {
                // nel caso di un accesso successivo al secondo esercizio controllo se ha risolto il precedente. Se non lo ha risolto, incremento il contatore
                // Alla fine se il contatore è maggiore o uguale a 2, ossia è passato al successivo ex senza risolvere quello prima per 2 volte, allora 
                // prendo questo studente. 

                bool ret = false;
                bool[] acc = new bool[LabInfo.totalExercise];
                bool[] solve = new bool[LabInfo.totalExercise];
                int cnt = 0; 
                for (int i = 0; i < seq.Sequence.Count; i++)
                {
                    Evento evento = seq.Sequence[i];
                    if (evento.Event == Evento.Accesso)
                    {
                        acc[evento.NumEsercizio - 1] = true;
                        
                    }
                    else if (evento.Event == Evento.Corretto)
                        solve[evento.NumEsercizio - 1] = true;

                }
                for (int j = 0; j < LabInfo.totalExercise; j++)
                {
                    if (acc[j] == true && solve[j] == false)
                    {
                        cnt++;
                    }
                }
                if (cnt > 2)
                    ret = true;

                return ret;
            }

            public static List<Sequenza> NoAccessToPreviousEx(List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (NoAccPrevEx(sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool NoAccPrevEx(Sequenza seq)
            {
                bool ret = true;
                bool[] acc = new bool[LabInfo.totalExercise];
                
                for (int i = 0; i < seq.Sequence.Count; i++)
                {
                    Evento evento = seq.Sequence[i];
                    if (evento.Event == Evento.Accesso)
                    {
                        if (acc[evento.NumEsercizio - 1] == true)
                        {
                            // ha già fatto accesso all'esercizio precedente!
                            ret = false;
                            break;
                        }
                        acc[evento.NumEsercizio - 1] = true;   
                    } 
                }

                return ret;
            }

            public static List<Sequenza> AccessToPreviousEx(int numTime, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (AccPrevEx(numTime, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool AccPrevEx(int numTime, Sequenza seq)
            {
                bool ret = false;
                bool[] acc = new bool[LabInfo.totalExercise];
                int cnt = 0;
                int previousAcc = 0;
                for (int i = 0; i < seq.Sequence.Count; i++)
                {
                    Evento evento = seq.Sequence[i];
                    if (evento.Event == Evento.Accesso)
                    {

                        if (acc[evento.NumEsercizio - 1] == true && evento.NumEsercizio < previousAcc)
                        {
                            // ha già fatto accesso all'esercizio precedente!
                            cnt++;
                        }
                        acc[evento.NumEsercizio - 1] = true;
                        previousAcc = evento.NumEsercizio;
                    }
                }

                if (cnt >= numTime)
                    ret = true;

                return ret;
            }
        }
        
        public class Solution
        {
            public static List<Sequenza> solveFirstNExercises(int numEs, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (firstExSolved(numEs, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool firstExSolved(int numEs, Sequenza sequenza)
            {
                bool ret = false;
                bool[] solved = new bool[LabInfo.totalExercise];
                int n = 0;
                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Corretto)
                        solved[evento.NumEsercizio - 1] = true;
                }

                for (int i = 0; i < LabInfo.totalExercise; i++)
                {
                    if (solved[i] == true)
                    {
                        n++;
                        if (n == numEs)
                            ret = true;
                    }
                    if (solved[i] == false && n < numEs)
                        break;
                }

                return ret;
            }


            public static List<Sequenza> solveAllExFirstTry(List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (solveExercisesFirst(sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }

            private static bool solveExercisesFirst(Sequenza sequenza)
            {
                bool ret = true;
                bool[] access = new bool[LabInfo.totalExercise];
                bool[] error = new bool[LabInfo.totalExercise];
                bool[] correct = new bool[LabInfo.totalExercise];

                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Accesso)
                    {
                        access[evento.NumEsercizio - 1] = true;
                    }
                    if (evento.Event == Evento.Errore)
                    {
                        error[evento.NumEsercizio - 1] = true;
                    }
                    if (evento.Event == Evento.Corretto)
                    {
                        correct[evento.NumEsercizio - 1] = true;
                    }
                }

                if (sequenza.Lunghezza == 1)
                    ret = false;

                for (int i = 0; i < LabInfo.totalExercise; i++)
                {
                    if (error[i] == true)
                        ret = false;
                    if (access[i] == true && (error[i] == true || correct[i] == false))
                        ret = false;
                }

                return ret;
            }

            public static List<Sequenza> solveNExercisesFirstTry(int n, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (solveNExFirst(n, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool solveNExFirst(int n, Sequenza sequenza)
            {
                bool ret = false;
                bool[] access = new bool[LabInfo.totalExercise];
                bool[] error = new bool[LabInfo.totalExercise];
                bool[] correct = new bool[LabInfo.totalExercise];

                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Accesso)
                    {
                        access[evento.NumEsercizio - 1] = true;
                    }
                    if (evento.Event == Evento.Errore)
                    {
                        error[evento.NumEsercizio - 1] = true;
                    }
                    if (evento.Event == Evento.Corretto)
                    {
                        correct[evento.NumEsercizio - 1] = true;
                    }
                }
                int cnt = 0;
                for (int i = 0; i < LabInfo.totalExercise; i++)
                {
                    if (access[i] == true && error[i] == false && correct[i] == true)
                        cnt++;

                    if (cnt >= n)
                        ret = true;
                }

                return ret;
            }






            public static List<Sequenza> errorOnAllExercises(List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (errorOnAllEx(sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }

            private static bool errorOnAllEx(Sequenza sequenza)
            {
                bool ret = true;
                bool[] access = new bool[LabInfo.totalExercise];
                bool[] error = new bool[LabInfo.totalExercise];

                if (sequenza.Sequence.Count == 1)
                    return false;

                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Accesso)
                    {
                        access[evento.NumEsercizio - 1] = true;
                    }
                    if (evento.Event == Evento.Errore)
                    {
                        error[evento.NumEsercizio - 1] = true;
                    }
                }

                for (int i = 0; i < LabInfo.totalExercise; i++)
                {
                    if (access[i] == true && error[i] == false)
                        ret = false;
                }

                return ret;
            }


            public static List<Sequenza> NerrorsOnAllExercises(int num, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (nerrorOnAllEx(num, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }

            private static bool nerrorOnAllEx(int num, Sequenza sequenza)
            {
                bool ret = true;
                bool[] access = new bool[LabInfo.totalExercise];
                int[] error = new int[LabInfo.totalExercise];
                for (int j = 0; j < LabInfo.totalExercise; j++) error[j] = 0;

                if (sequenza.Lunghezza == 1)
                    return false;

                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Accesso)
                    {
                        access[evento.NumEsercizio - 1] = true;
                    }
                    if (evento.Event == Evento.Errore)
                    {
                        error[evento.NumEsercizio - 1]++;
                    }
                }

                for (int i = 0; i < LabInfo.totalExercise; i++)
                {
                    if (access[i] == true && error[i] < num)
                        ret = false;
                }

                return ret;
            }

            public static List<Sequenza> atLeastXerrorsOnYExercises(int xErr, int yExercises, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (filterErrorOnEx(xErr, yExercises, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }

            private static bool filterErrorOnEx(int numError, int numExercises, Sequenza sequenza)
            {
                bool ret = false;
                bool[] access = new bool[LabInfo.totalExercise];
                int[] error = new int[LabInfo.totalExercise];
                for (int j = 0; j < LabInfo.totalExercise; j++) error[j] = 0;

                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Accesso)
                    {
                        access[evento.NumEsercizio - 1] = true;
                    }
                    if (evento.Event == Evento.Errore)
                    {
                        error[evento.NumEsercizio - 1]++; // conto gli errori su un esercizio
                    }
                }

                int cnt = 0;
                for (int i = 0; i < LabInfo.totalExercise; i++)
                {
                    if (access[i] == true && error[i] >= numError)
                        cnt++;
                    if (cnt >= numExercises)
                        ret = true;
                }

                return ret;
            }

            internal static bool FirstTryCheckNotError(int numEx, Sequenza sub)
            {
                bool ret = false; // dò per scontato che ci siano errori
                bool[] access = new bool[LabInfo.totalExercise];
                bool[] solved = new bool[LabInfo.totalExercise];
                bool[] error = new bool[LabInfo.totalExercise];

                foreach(Evento evento in sub.Sequence)
                {
                    if (evento.Event == Evento.Accesso)
                    {
                        access[evento.NumEsercizio - 1] = true;
                    }
                    if (evento.Event == Evento.Errore)
                    {
                        error[evento.NumEsercizio - 1] = true;
                    }
                    if (evento.Event == Evento.Corretto)
                    {
                        solved[evento.NumEsercizio - 1] = true;
                    }
                }

                int cnt = 0; 
                for(int i = 0; i < LabInfo.totalExercise; i++)
                {
                    if (access[i] && solved[i] && !error[i]) // se l'esercizio è risolto senza errori
                        cnt++;
                }

                if (cnt >= numEx) // ci sono almeno numEx esercizi risolti senza errori
                    ret = true; 

                return ret; 
            }

            public static List<Sequenza> atLeastXerrors(int xErr, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (filterError(xErr, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }

            private static bool filterError(int numError, Sequenza sequenza)
            {
                bool ret = false;
                bool[] access = new bool[LabInfo.totalExercise];
                int[] error = new int[LabInfo.totalExercise];
                for (int j = 0; j < LabInfo.totalExercise; j++) error[j] = 0;

                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Accesso)
                    {
                        access[evento.NumEsercizio - 1] = true;
                    }
                    if (evento.Event == Evento.Errore)
                    {
                        error[evento.NumEsercizio - 1]++; // conto gli errori su un esercizio
                    }
                }

                int cnt = 0;
                for (int i = 0; i < LabInfo.totalExercise; i++)
                {
                    if (access[i] == true && error[i] >= 0)
                        cnt += error[i];
                    if (cnt >= numError)
                        ret = true;
                }

                return ret;
            }




        }

        public class Assistance
        {
            public static List<Sequenza> manyAssistanceRequest(int numReq, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (atLeastNumAssistanceReq(numReq, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }

            private static bool atLeastNumAssistanceReq(int numReq, Sequenza sequenza)
            {
                bool ret = false;
                int cnt = 0;

                foreach (Evento evento in sequenza.getEvents())
                {
                    if (evento.Event == Evento.RichiestaIntervento)
                        cnt++;
                }

                if (cnt >= numReq)
                    ret = true;

                return ret;
            }

            public static List<Sequenza> noAssistanceRequest(List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (hasAssistanceRequest(sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }

            private static bool hasAssistanceRequest(Sequenza sequenza)
            {
                bool ret = true;

                if (sequenza.Sequence.Count == 1 && (sequenza.Sequence.Last().Event != Evento.Intervento || sequenza.Sequence.Last().Event != Evento.RichiestaIntervento))
                    return false;

                foreach (Evento evento in sequenza.getEvents())
                {
                    if (evento.Event == Evento.RichiestaIntervento)
                    {
                        ret = false;
                        break;
                    }
                }
                return ret;
            }

            public static List<Sequenza> AssistanceRequestOnAllEx(List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (reqOnAllEx(sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool reqOnAllEx(Sequenza sequenza)
            {
                bool ret = true;
                bool[] access = new bool[LabInfo.totalExercise];
                bool[] req = new bool[LabInfo.totalExercise];


                if (sequenza.Sequence.Count == 1 && (sequenza.Sequence.Last().Event != Evento.Intervento || sequenza.Sequence.Last().Event != Evento.RichiestaIntervento))
                    return false; 

                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Accesso)
                    {
                        access[evento.NumEsercizio - 1] = true;
                    }
                    if (evento.Event == Evento.RichiestaIntervento)
                    {
                        req[evento.NumEsercizio - 1] = true;
                    }

                }

                for (int i = 0; i < LabInfo.totalExercise; i++)
                {
                    if (access[i] == true && req[i] == false)
                        ret = false;
                }


                return ret;
            }

            public static List<Sequenza> manyAssistanceRequestOnNexesercises(int numReq, int numEx, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (atLeastNumAssistanceReqOnNex(numReq, numEx, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }

            private static bool atLeastNumAssistanceReqOnNex(int numReq, int numEx, Sequenza sequenza)
            {
                bool ret = false;
                int cnt = 0;
                int[] ex = new int[LabInfo.totalExercise];

                foreach (Evento evento in sequenza.getEvents())
                {
                    if (evento.Event == Evento.RichiestaIntervento)
                        ex[evento.NumEsercizio - 1]++;
                }

                for (int i = 0; i < LabInfo.totalExercise; i++)
                    if (ex[i] >= numReq)
                        cnt++;

                if (cnt >= numEx)
                    ret = true;

                return ret;
            }


            public static List<Sequenza> AssistanceThenImmediatelyCorrect(List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (positiveAssistanceThenOk(sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool positiveAssistanceThenOk(Sequenza sequenza)
            {
                bool ret = false;
                int exhelp = 0;
                int i = 0;
                int temp = 0;

                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Intervento)
                    {
                        exhelp = evento.NumEsercizio;
                        temp = i;
                    }
                    if (evento.Event == Evento.Corretto)
                        if (temp == i - 1 && exhelp == evento.NumEsercizio)
                            ret = true;
                    i++;
                }

                return ret;
            }

            public static List<Sequenza> AssistanceThenImmediatelyError(List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (positiveAssistanceThenError(sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool positiveAssistanceThenError(Sequenza sequenza)
            {
                bool ret = false;
                int exhelp = 0;
                int i = 0;
                int temp = 0;

                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Intervento)
                    {
                        exhelp = evento.NumEsercizio;
                        temp = i;
                    }
                    if (evento.Event == Evento.Errore)
                        if (temp == i - 1 && exhelp == evento.NumEsercizio)
                            ret = true;
                    i++;
                }

                return ret;
            }

            public static List<Sequenza> AssistanceThenCorrect(List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (positiveAssistance(sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool positiveAssistance(Sequenza sequenza)
            {
                bool ret = false;
                int exhelp = 0;


                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Intervento)
                    {
                        exhelp = evento.NumEsercizio;
                    }
                    if (evento.Event == Evento.Corretto)
                        if (exhelp == evento.NumEsercizio)
                            ret = true;
                }

                return ret;
            }

        }

        public class Time
        {
            static long tempo;
            public static List<Sequenza> SecondsBetweenAccessAndNext(int time, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (secBetAccessAndNext(time, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool secBetAccessAndNext(int time, Sequenza sequenza)
            {
                bool ret = false;
                Evento ultimoaccesso = null;
                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Accesso)
                    {
                        if (ultimoaccesso != null)
                        {
                            tempo = Evento.timeSecondDistance(ultimoaccesso, evento);
                            if (tempo >= time && evento.NumEsercizio == ultimoaccesso.NumEsercizio + 1)
                                ret = true;
                        }
                        

                        ultimoaccesso = evento;
                    }

                }


                return ret;
            }

            public static List<Sequenza> SecondsBetweenAccessAndCorrect(int time, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (secBetAccessAndCorr(time, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool secBetAccessAndCorr(int time, Sequenza sequenza)
            {
                bool ret = false;
                Evento[] firstAccesses = new Evento[LabInfo.totalExercise];


                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Accesso)
                    {
                        if(firstAccesses[evento.NumEsercizio-1] == null)
                        {
                            firstAccesses[evento.NumEsercizio - 1] = evento;
                        }
                    }

                    if(evento.Event == Evento.Corretto)
                    {
                        if (Evento.timeSecondDistance(firstAccesses[evento.NumEsercizio-1], evento) >= time)
                            ret = true;
                    }
                }


                return ret;
            }

            public static List<Sequenza> SecondsBetweenTryAndNextTry(int time, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (secBetTryAndTry(time, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool secBetTryAndTry(int time, Sequenza sequenza)
            {
                bool ret = false;
                Evento ultimotry = null;

                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Errore || evento.Event == Evento.Corretto)
                    {
                        if(ultimotry != null)
                        {
                            if(evento.NumEsercizio == ultimotry.NumEsercizio && Evento.timeSecondDistance(ultimotry, evento) >= time)
                            {
                                ret = true;
                            }
                        }

                        ultimotry = evento;
                    }    
                }

                return ret;
            }


            public static List<Sequenza> SecondsBetweenAssistanceAndCorrect(int time, List<Sequenza> sequences)
            {
                List<Sequenza> ret = new List<Sequenza>();

                foreach (Sequenza sequenza in sequences)
                {
                    if (secBetAssAndCorr(time, sequenza))
                        ret.Add(sequenza);
                }

                return ret;
            }
            private static bool secBetAssAndCorr(int time, Sequenza sequenza)
            {
                bool ret = false;
                Evento ultimointervento = null;

                foreach (Evento evento in sequenza.Sequence)
                {
                    if (evento.Event == Evento.Intervento)
                    {
                        ultimointervento = evento;
                    }

                    if (evento.Event == Evento.Corretto)
                    {
                        if (ultimointervento != null && evento.NumEsercizio == ultimointervento.NumEsercizio &&
                                Evento.timeSecondDistance(ultimointervento, evento) >= time)
                            ret = true;
                    }

                }

                return ret;
            }

        }
        
    }
}
