﻿using SQL_lab_analysis.Classi;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SQL_lab_analysis
{
    /// <summary>
    /// Logica di interazione per MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public string path;
        public string[] filePaths;
        public string[] fileNames;
        public MyFile[] FileNames;
        public ObservableCollection<MyFile> FileList;
        public bool MinLen { get; set; }
        public bool esPrec { get; set; }
        public bool isCorr { get; set; }
        public bool isErr { get; set; }
        public bool isLung { get; set; }
        public bool isFreqGap { get; set; }
        public bool isRipeted { get; set; }
        public bool isDistinctErr { get; set; }
        public bool isDistinctCorr { get; set; }
        public int esCorretti { get; set; }
        public int esSbagliati { get; set; }
        public int lunghezzaSeq { get; set; }
        public int freqMin { get; set; }
        public int freqMax { get; set; }
        public int esRipetuti { get; set; }
        public int esDistinctSbagliati { get; set; }
        public int esDistinctCorr { get; set; }

        private List<Results> windows;
        TestoEsercizi t1, t2;
        Categories cat;
        StudentsSequence wind;
        public LabInfo labInfo;

        public MainWindow()
        {
            InitializeComponent();
            this.AllowDrop = true;
            labInfo = new LabInfo();
            FileList = new ObservableCollection<MyFile>();
            Files.ItemsSource = FileList;
            windows = new List<Results>();
            esPrec = false;

        }

        private void Window_Drop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop, true))
            {
                string[] droppedFilePaths = e.Data.GetData(DataFormats.FileDrop, true) as string[];
                filePaths = droppedFilePaths;

                FileList.Clear();
                FileNames = getFilename(droppedFilePaths);

                path = getFilesNames(FileNames);
                MyFilePath.Foreground = Brushes.Black;
                MyFilePath.Text = path;
                StackHolder.Visibility = Visibility.Hidden;
            }
        }
        private MyFile[] getFilename(string[] vett)
        {
            MyFile[] res = new MyFile[vett.Length];
            for (int i = 0; i < vett.Length; i++)
            {
                MyFile f = new MyFile(vett[i]);
                res[i] = f;
                FileList.Add(f);
            }
            return res;

        }
        private string getFilesNames(MyFile[] files)
        {
            string res = "";

            foreach (MyFile f in files)
            {
                res += f.FileName;
                if (f != files.Last())
                    res += ", ";
            }
            return res;
        }


        private void first_Click(object sender, RoutedEventArgs e)
        {
            if (path == null || string.IsNullOrEmpty(path))
            {
                MyFilePath.Foreground = Brushes.Red;
                return;
            }

            Results res = new Results(path);
            if(res.closing == false)
            {
                windows.Add(res);
                res.Show();
            }
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (cat != null)
                cat.Close();
            if (wind != null)
                wind.Close();
            if (t1 != null)
                t1.Close();
            if (t2 != null)
                t2.Close();
            foreach (Results r in windows)
                r.Close();
        }



        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {
            if (t1 == null)
            {
                t1 = new TestoEsercizi(0);
                t1.Show();
            }
            else
                t1.Focus();

        }
        private void MenuItemSoluzioni_Click(object sender, RoutedEventArgs e)
        {
            if (t2 == null)
            {
                t2 = new TestoEsercizi(1);
                t2.Show();
            }
            else
                t2.Focus();
        }


        private void studentSequences_Click(object sender, RoutedEventArgs e)
        {
            if (wind == null)
            {
                wind = new StudentsSequence();
                wind.Show();
            }
            else
                wind.Focus();
        }

        private void TotalNumberExercises_Click(object sender, RoutedEventArgs e)
        {
            setTotalExercises();
        }

        public void setTotalExercises()
        {
            DialogInput dialog = new DialogInput("Insert the total number of exercises of the laboratory.");

            if (dialog.ShowDialog() == true)
            {
                string[] vet = new string[1];
                vet[0] = dialog.UserInput;
                File.WriteAllLines(FilePath.Numex, vet);
                LabInfo.readNumEx();
            }
        }
        private void studentsCategories_Click(object sender, RoutedEventArgs e)
        {
            if (cat == null)
            {
                List<Evento> eventi = new List<Evento>();
                cat = new Categories(FileList, eventi);
                cat.Show();
            }
            else
                cat.Focus();
        }
    }
}
