﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace SQL_lab_analysis
{
    /// <summary>
    /// Logica di interazione per RicercaSottosequenza.xaml
    /// </summary>
    public partial class RicercaSottosequenza : Window
    {
        private ObservableCollection<Evento> ricercato;
        private ObservableCollection<Evento> possibilita;
        public List<Sequenza> searchResults;
        private bool ricercaEsatta;


        Results results;
        Categories categories;

        public RicercaSottosequenza(Window window, List<Evento> list, bool exact)
        {
            InitializeComponent();
            ricercato = new ObservableCollection<Evento>();
            Ricerca.ItemsSource = ricercato;


            var ordered = list.OrderBy(e => e.EventNum).ThenBy(e => e.NumEsercizio);

            possibilita = new ObservableCollection<Evento>();

            foreach (Evento e in ordered)
                possibilita.Add(e);


            searchResults = new List<Sequenza>();
            Elementi.ItemsSource = possibilita;

            if (window is Results)
                results = window as Results;
            else if (window is Categories)
                categories = window as Categories;


            ricercaEsatta = exact;
        }

        private void AggiungiEvento(object sender, MouseButtonEventArgs e)
        {
            Console.WriteLine("Eccoci");
            Border b = (Border)sender;

            string textes = ((TextBlock)b.Child).Text.ToString();
            int es = int.Parse(textes.Trim());
            int eventtype = 0;

            if (b.Background == FindResource("LightBlue"))
                eventtype = 1;
            else if (b.Background == FindResource("Red"))
                eventtype = 2;
            else if (b.Background == FindResource("Green"))
                eventtype = 3;
            else if (b.Background == FindResource("Orange"))
                eventtype = 4;
            else if (b.Background == FindResource("Yellow"))
                eventtype = 5;
            Evento e1 = new Evento(es, eventtype);

            ricercato.Add(e1);
            CloseX.Visibility = Visibility.Visible;
        }

        private void Find_Click(object sender, RoutedEventArgs e)
        {
            Evento[] events = ricercato.ToArray();
            Sequenza s = new Sequenza(events, 1);

            if (s.Lunghezza == 0)
                return;

            if (ricercaEsatta == false)
                searchSequenza(s);
            else
                searchSequenzaEsatta(s);
        }

        public void searchSequenza(Sequenza sequenza)
        {
            if (results != null)
            {
                foreach (Sequenza seq in results.Sequences)
                {
                    if (seq.Contains(sequenza))
                        searchResults.Add(seq);
                }
                Console.WriteLine("Search ended.");

                Results res = new Results(searchResults);
                res.Show();
            }
            else if (categories != null)
            {
                foreach (Sequenza seq in categories.sequences)
                {
                    if (seq.Contains(sequenza))
                        searchResults.Add(seq);
                }
                Console.WriteLine("Search ended.");

                Categories res = new Categories(searchResults);
                res.Show();
            }
            this.Close();
        }
        public void searchSequenzaEsatta(Sequenza sequenza)
        {

            if (results != null)
            {
                foreach (Sequenza seq in results.Sequences)
                {
                    if (seq.Equals(sequenza))
                        searchResults.Add(seq);

                }
                Console.WriteLine("Search ended.");
                Results res = new Results(searchResults);
                res.Show();
            }
            else if (categories != null)
            {
                foreach (Sequenza seq in categories.sequences)
                {
                    if (seq.Equals(sequenza))
                        searchResults.Add(seq);

                }
                Console.WriteLine("Search ended.");
                Categories cat = new Categories(searchResults);
            }

            this.Close();
        }

        private void CloseX_Click(object sender, MouseButtonEventArgs e)
        {
            ricercato.Clear();
            CloseX.Visibility = Visibility.Hidden;
        }
    }
}
