﻿using SQL_lab_analysis.Classi;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace SQL_lab_analysis
{
    /// <summary>
    /// Logica di interazione per SelectJoinCategories.xaml
    /// </summary>
    public partial class SelectJoinCategories : Window
    {
        private ObservableCollection<Categoria> categorie;
        private ObservableCollection<MyFile> inputs;

        public SelectJoinCategories(ObservableCollection<Categoria> categories, ObservableCollection<MyFile> input)
        {
            InitializeComponent();
            categorie = categories;
            CategoriesList.ItemsSource = categorie;
            inputs = input;
        }

        private void JoinCategories_Click(object sender, RoutedEventArgs e)
        {
            List<Categoria> categs = new List<Categoria>();
            foreach (Categoria cat in categorie)
            {
                if (cat.selected == true)
                {
                    categs.Add(cat);
                    Console.WriteLine("Added " + cat.FullName + ".");

                }
            }

            JoinCategories join = new JoinCategories(new ObservableCollection<Categoria>(categs), inputs);
            join.Show();
            this.Close();
        }

        private void CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            CheckBox check = sender as CheckBox;
            Categoria cat = check.DataContext as Categoria;
            cat.selected = true;
        }

        private void CheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            CheckBox check = sender as CheckBox;
            Categoria cat = check.DataContext as Categoria;
            cat.selected = false;
        }
    }
}
