#!/bin/bash


PARSED_OPTIONS=$(getopt -n "$0" -o hs:r:u:l:w:d:Z: --long "help,minsup:,result:,maxgap:,mingap:,maxwindow:,dir:,maxseq:" -- "$@")
if [ $? -ne 0 ]
then 
	exit 1
fi

eval set --"$PARSED_OPTIONS"

while true;
do
case "$1" in
	-h|--help)
		echo
		echo "-s, --minsup: minimum support of the item to be consider frequent, i.e. percentage of sequences in which the item/itemset has to show up."
		echo "-r, --result: name of the output file."
		echo "-u, --maxgap: maxgap allowed between itemset within the same sequence (eid/time)."
		echo "-l, --mingap: mingap allowed between itemset within the same sequence (eid/time)."
		echo "-w, --maxwindow: max time window of a subsequence"
		echo "-d, --dir: directory where to save output inside 'results' folder. If not specified, results are saved in the 'results' folder."
	shift;;
	-s|--minsup)
		echo "Minsup: $2"
		minsup=$2
	shift 2;;
	-r|--result)
		echo "File output: $2"
		result=$2
	shift 2;;	
	-u|--maxgap):
		echo "Maxgap: $2"
		maxgap=$2
	shift 2;;
	-l|--mingap):
		echo "Mingap: $2"
		mingap=$2
	shift 2;;
	-w|--maxwindow):
		echo "Maxwindows: $2"
		maxwindow=$2
	shift 2;;
	-d|--dir):
		echo "Directory: $2"
		directory=$2
	shift 2;;
	-Z|--maxseq):
		maxlen=$2
	shift 2;;
	--)
	break;;	
	
esac
done

if [ -z "$minsup" ] | [ -z "$directory" ] #controllo se i parametri sono settati  
then
	echo
	echo "Wrong arguments."
	echo "Mandatory:"
	echo "-s, --minsup: minimum support of the item to be consider frequent, i.e. percentage of sequences in which the item/itemset has to show up."
	
	echo "Optional:"
	echo "-u, --maxgap: maxgap allowed between itemset within the same sequence (eid/time)."
	echo "-l, --mingap: mingap allowed between itemset within the same sequence (eid/time)."
 	echo "-w, --maxwindow: max time window of a subsequence."
   echo "example: ./cspade.sh -i filename -s minsup -r result"
   exit -1
fi

params="--minsup $minsup "
if [ ! -z $mingap ]
then
	params=$params"--mingap $mingap "
fi

if [ ! -z $maxgap ]
then
	params=$params"--maxgap $maxgap "
fi
if [ ! -z $maxwindow ]
then
	params=$params"--maxwindow $maxwindow "
fi
if [ ! -z $maxlen]
then
	params=$params"--maxseq $maxlen "
fi

p8="-d $directory/lab -i lab.data "$params

fileparam=results/$directory/params
num=$(awk 'END {print NR}' $fileparam)
num=$(($num+1))
printf -v num "%02d" $num
echo "ris$num: $params" >> $fileparam


com="./cspade.sh "$p8
echo $com
$com



